// $Id: class_CompanionDisplayer.js,v 1.15 2004/10/28 02:41:38 dviner Exp $

// the edit box object probably should be in a different file
// but currently it has no properties, and is just a placeholder
function EditBox(width)
{
	this.width = width;
}
function Label()
{
}

function CompanionDisplayer()
{
    this.toolBarId = null;
    this.itemIdx = 0;
    this.imgMap = new ImageResolver();
    this.UseIconsAndNames = true;
    this.AlertButtonId = "";
    this.charset = "iso-8859-1";

}

// set the reference to the toolbar container.. this is an element
// from the browser, as from:
// document.getElementById(myToolbarId)
CompanionDisplayer.prototype.setToolBarId = function(tb)
{
    this.toolBarId = tb;
}

// now we actually display the items.
// this is really a 2 step process...
// 1. build up a new toolbox element...
// 2. append it to the this.toolbar
// 3. hide the static toolbar
// 4. display the dynamic toolbar.
CompanionDisplayer.prototype.display = function(items)
{
    var dynamicToolBar = new Array();
    
    // now build all the elements from the items array
    var i = 0;
    for( ; i < items.length ; i++)
    {
        var it = null;
        if(items[i].constructor == Button)
        {
            it = this.buildButton(items[i]);
        }
        else if(items[i].constructor == ButtonMenu)
        {
            it = this.buildButtonMenu(items[i]);
        }
        else if(items[i].constructor == Menu)
        {
            it = this.buildMenu(items[i], false);
        }
        else if(items[i].constructor == EditBox)
        {
            it = this.buildEditBox(items[i]);
        }
        else if(items[i].constructor == Label)
        {
            it = this.buildLabel(items[i]);
        }
        else
        {
            alert("Don't know how to add a " + items[i].constructor);
        }
        if(it != null)
            dynamicToolBar.push(it);
    }    
    
    var buttonBox = document.createElement("hbox");
    buttonBox.flex = 1;
    

    for(var p=0 ; p < dynamicToolBar.length; p++)
    {
        dynamicToolBar[p].setAttribute("collapsed","false");
        dynamicToolBar[p].setAttribute("inherits","hidden");
        buttonBox.appendChild(dynamicToolBar[p]);
    }
    
    
    
    // first we see if we already have a toolbar.
    // if so, then hide everything in it, and add these new elements.
    var dynToolBar;
    dynToolBar = document.getElementById('yahootoolbar_dyn');
    if(dynToolBar == null)
    {
        //alert("Creating new dynamic toolbar");
        dynToolBar = document.createElement("toolbar");
        dynToolBar.setAttribute("id","yahootoolbar_dyn");
        dynToolBar.setAttribute("grippytooltiptext","Yahoo! Toolbar");
        var mainBox = document.getElementById('navigator-toolbox');
     	mainBox.appendChild(dynToolBar);
    }
    else
    {
        //alert("replacing existing toolbar.");
        // hide everything under it
        
        // now actually remove the toolbar, not just hiding it.
        while (dynToolBar.hasChildNodes())
            dynToolBar.removeChild(dynToolBar.firstChild);
        
        /* this was the code to hide it
        var tmp = dynToolBar.childNodes;
        for(var q=0; q < tmp.length; q++)
        {
            tmp[q].setAttribute("hidden","true");
        }
        */
    }
    
    dynToolBar.appendChild(buttonBox);

}

CompanionDisplayer.prototype.buildEditBox = function(ed)
{
    var dynBox = document.createElement("menulist");
    dynBox.setAttribute("id","yahootoolbarSearchTextDyn");
    dynBox.setAttribute("class","yahootoolbarSearchText");
    dynBox.setAttribute("editable","true");

    // Set the width according to the Yahoo! feed.  
    dynBox.width = ed.width * 9;
    // Set 'sizetopopup' to prevent the popup menu from truncating at the menu width
    dynBox.setAttribute("sizetopopup","no");
    
    dynBox.setAttribute("onkeypress","if(event.keyCode == 13) { yahootoolbar.dynSearch(); } ");
    
    // we need to add any existing search terms
    this.saveOldSearchTerms(dynBox, "yahootoolbarSearchTextDyn");
    //var oldMenuList = document.getElementById("yahootoolbarSearchTextDyn");
    
    return dynBox;
}
CompanionDisplayer.prototype.saveOldSearchTerms = function(newBox, oldName)
{
    var oldMenuList = document.getElementById(oldName);
    if(oldMenuList != null)
    {
        //alert("Cloning old search terms.");
        var tmp = oldMenuList.childNodes;
        for(var n=0; n < tmp.length; n++)
        {
            //alert("Added term from " + tmp[n]);
            //newBox.insertItemAt(n, tmp[n]);
            newBox.appendChild(tmp[n]);
        }
        
        // Now copy the "hidden" attribute
        newBox.hidden = oldMenuList.hidden;
    }
    
}
CompanionDisplayer.prototype.buildButtonMenu = function(bm)
{
    var dynBm = null;
    dynBm = document.createElement("toolbarbutton");
    var myid = "dynmenubutton" + this.itemIdx;
    this.itemIdx++;
    dynBm.setAttribute("id", myid);
    dynBm.setAttribute("class","yahoobuttonmenu");
    dynBm.setAttribute("type","menu-button");
    dynBm.setAttribute("tooltiptext", bm.getTitle());
    
    // since these are MENU-BUTTONs, we need to make sure that
    // the target of the click event is the button, otherwise
    // a click on any item in the menu will be handled first by
    // that item, then by the button. Hence the "if(event.target..."
    if(bm.isSearch())
    {
        var act = "if(event.target == this) { yahootoolbar.dynSearch('"+bm.getLink()+"'); }";
        dynBm.setAttribute("oncommand",act);
    }
    else
    {
        var act = "if(event.target == this) { yahootoolbar.LoadPage('"+bm.getLink()+"'); }";
        dynBm.setAttribute("oncommand",act);
    }

    // first set the "button" parts
	// might wanna put support for other languages here at some point
	if (this.UseIconsAndNames || bm.getImage() == "")
	    dynBm.setAttribute("label", bm.getTitle());
    dynBm.setAttribute("image", this.imgMap.getUrl(bm.getImage()));

    // now set the menu parts.
    dynBm.appendChild(this.buildMenuPopup(bm.getItems(), bm.isSearch()));
    return dynBm;
}
CompanionDisplayer.prototype.buildMenu = function(menu, nestedMenu)
{
    var dynMenu = null;

	// cjh - there's a better way... scroll down
    // some menu's are shown, like Alerts when there are no items.
    //if(! menu.isDisplayable())
    //    return null;

    // we need a different style class for nested menus
    if (nestedMenu) {
        dynMenu = document.createElement("menu");
        dynMenu.setAttribute("class","yahoonestedbuttonmenu");
        dynMenu.setAttribute("label", menu.getTitle());
        dynMenu.setAttribute("tooltiptext", null);
    } else {
        dynMenu = document.createElement("toolbarbutton");
        dynMenu.setAttribute("class","yahoobuttonmenu");
        if (this.UseIconsAndNames)
    dynMenu.setAttribute("label", menu.getTitle());
        dynMenu.setAttribute("tooltiptext", menu.getTitle());
    }
    dynMenu.setAttribute("image", this.imgMap.getUrl(menu.getImage()));
    dynMenu.setAttribute("type","menu");


    // first we make the menu item itself
    var myid = "dynmenu" + this.itemIdx;
    this.itemIdx++;
    dynMenu.setAttribute("id", myid);

	// If there are no alert items, create the menu button
	// but don't display it.
    if(menu.getType() == "alert")
    {
		this.AlertButtonId = myid;

        if(menu.items.length == 0)
        {
			dynMenu.setAttribute("style","display:none;");
		}
    }

    // now build the items inside the menu
    dynMenu.appendChild(this.buildMenuPopup(menu.getItems()));
	
    return dynMenu;
}

CompanionDisplayer.prototype.buildMenuPopup = function(items, isSearch)
{
    if(isSearch == null)
        isSearch = false;
    var popup = document.createElement("menupopup");
    for( var i = 0; i < items.length ; i++)
    {
        var mli = items[i];
        var dynMli = null;
        if(mli.constructor == MenuItem)
        {
            // build a menu item
            dynMli = this.buildMenuItem(mli, isSearch);
        }
        else
        {
            // this is a nested menu!
            dynMli = this.buildMenu(mli, true);
        }
        popup.appendChild(dynMli);
    }
    return popup;
}
CompanionDisplayer.prototype.buildMenuItem = function(mi, isSearch)
{
    var dynMi = null;
    var myid = "dynmenuitem" + this.itemIdx;
    this.itemIdx++;
    
    if(mi.isSeparator())
    {
        dynMi = document.createElement("menuseparator");
    }    
    else
    {
        dynMi = document.createElement("menuitem");
        dynMi.setAttribute("label", mi.getTitle());
        dynMi.setAttribute("tooltiptext", null);
        if(mi.isRefresh())
        {
            dynMi.setAttribute("oncommand","yahootoolbar.dynOpen();");
        }
        else if(mi.isUninstall())
        {
            // Add uninstall here!
            dynMi.setAttribute("oncommand","yahootoolbar.Uninstall();");
        }
		else if(mi.isAbout())
		{
            dynMi.setAttribute("oncommand","yahootoolbar.showAbout();");
		}
        else if(mi.isAddBookmark())
        {
            // directly call bookmark api
            var url="http://e.my.yahoo.com/config/add_site?";
            // now we need the folder id, url, and name
            url += ".folder=" + mi.getLink();
            
            // what we actually need here is to make a background request
            var js = "var d = window._content.document; ";
            js += "var url2='"+url+"&.name='+escape(d.title)+'&.url='+escape(d.location);";
            //js += "alert('URL to add is: ' + url2);"
            js += " var obj = new XMLHttpRequest();" ;
            js += " obj.open('GET',url2);" ;
            js += " obj.send(null); " ;
            
            // what we need here is a way to refresh the toolbar.
            // but how to do that from javascript?
            // for now, just tell the user we added it
            //js += " setTimeout(); ";
             
            // Set the countdown timer to zero so the next refresh will refresh all
            js += " yahootoolbar.refreshcnt = 0; " ;
            js += " alert('Added Bookmark.  Refresh Toolbar to see the link.');";
            
            js += "return true;";
            //var js = "yahootoolbar.LoadPage('"+url+"'); return true;";
            dynMi.setAttribute("oncommand",js);
        }
		else if(mi.isIconOnlyToggle())
		{
            var link = mi.getLink();
            if(link != null)
            {
				// cjh: need to fix some stuff before enabling this
				//setTimeout("yahootoolbar.dynOpen()",60000);
				
                var act = "";
                if(isSearch)
                {
                    act = "yahootoolbar.dynSearch('"+mi.getLink()+"'); return true;";
                }
                else
                    act = "yahootoolbar.LoadPage('"+mi.getLink()+"'); return true;";
                
				dynMi.setAttribute("oncommand",act);
			}
		}
        else
        {
            var link = mi.getLink();
            if(link != null)
            {
                var act = "";
                if(isSearch)
                {
                    act = "yahootoolbar.dynSearch('"+mi.getLink()+"'); return true;";
                    //alert('search for ' + mi.getTitle());
                }
                else
                    act = "yahootoolbar.LoadPage('"+mi.getLink()+"'); return true;";
                
				dynMi.setAttribute("oncommand",act);
            }
            //else
            //    alert("HEY: mi: " + mi.getTitle() + " has no link!");
        }
    }
    
    dynMi.setAttribute("id", myid);
    return dynMi;
}


CompanionDisplayer.prototype.buildButton = function(but)
{
    // buildButton sometimes returns a separator...
    // the companion feed considers a Separator a button...
    if(but.isSeparator())
    {
        // ok... we need to build a separator, not a button.
        var sep = document.createElement("toolbarseperator");
        var myid  = "dynsep"+this.itemIdx;
        this.itemIdx++;
        sep.setAttribute("id",myid);
        return sep;
    }
    else
    {
        var button = document.createElement("toolbarbutton");
        button.setAttribute("class", "yahoobutton");
        var myid = "dynbutton"+this.itemIdx;
        this.itemIdx++;
        button.setAttribute("id",myid);
        if(but.isSearchToggle())
        {
			button.setAttribute("label",but.getTitle());
            button.setAttribute("image",this.imgMap.getUrl(but.getImage()));
            var act = "var sb = document.getElementById('yahootoolbarSearchTextDyn'); if(sb.getAttribute('hidden') == 'true'){sb.setAttribute('hidden','');} else {sb.setAttribute('hidden','true');} "
            button.setAttribute("oncommand",act);
        }
        else
        {
            if (this.UseIconsAndNames)
            button.setAttribute("label", but.getTitle());
            button.setAttribute("tooltiptext", but.getTitle());
            button.setAttribute("image",this.imgMap.getUrl(but.getImage()));
            var act = "yahootoolbar.LoadPage('"+but.getLink()+"')";
            button.setAttribute("oncommand",act);
        }
        return button;
    }
}

// returns the offline label
// XXX: this could be made more generic for any label
CompanionDisplayer.prototype.buildLabel = function(label)
{
    var label = document.createElement("label");
    label.setAttribute("value", "...attempting to retrieve buttons from Yahoo!...");
    return label;
}
